> ## Documentation Index
> Fetch the complete documentation index at: https://tbd-6fc993ce-hypeship-document-audit-logs-api.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a deployment

> Create a new deployment.



## OpenAPI

````yaml https://app.stainless.com/api/spec/documented/kernel/openapi.documented.yml post /deployments
openapi: 3.1.0
info:
  title: Kernel API
  description: Developer tools and cloud infrastructure for AI agents to use web browsers
  version: 0.1.0
servers:
  - url: https://api.onkernel.com
    description: API Server
security:
  - bearerAuth: []
tags:
  - name: Browsers
    description: Create and manage browser sessions.
  - name: Browser Computer Controls
    description: Control mouse, keyboard, and screen on the browser instance.
  - name: Browser Playwright
    description: Execute Playwright code against the browser instance.
  - name: Browser Filesystem
    description: Read, write, and manage files on the browser instance.
  - name: Browser Processes
    description: Execute and manage processes on the browser instance.
  - name: Browser Replays
    description: Record and manage browser session video replays.
  - name: Browser Logs
    description: Stream logs from the browser instance.
  - name: Browser Telemetry
    description: Stream live telemetry events from a browser session.
  - name: Profiles
    description: Create, list, retrieve, and delete browser profiles.
  - name: Proxies
    description: Create and manage proxy configurations for routing browser traffic.
  - name: Extensions
    description: Create, list, retrieve, and delete browser extensions.
  - name: Browser Pools
    description: Create and manage browser pools for acquiring and releasing browsers.
  - name: Managed Auth
    description: >-
      Create and manage auth connections for automated credential capture and
      login.
  - name: Credentials
    description: Create and manage credentials for authentication.
  - name: Credential Providers
    description: Configure external credential providers like 1Password.
  - name: Apps
    description: List applications and versions.
  - name: Deployments
    description: Create and manage app deployments and stream deployment events.
  - name: Invocations
    description: Invoke actions and stream or query invocation status and events.
  - name: Organization
    description: Read and manage organization-level limits.
  - name: Projects
    description: Create and manage projects for resource isolation within an organization.
  - name: API Keys
    description: Create and manage API keys for organization and project-scoped access.
  - name: Audit Logs
    description: Read audit log records for the authenticated organization.
paths:
  /deployments:
    post:
      tags:
        - Deployments
      summary: Create a deployment
      description: Create a new deployment.
      operationId: postDeployments
      requestBody:
        description: App deployment data
        required: true
        content:
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/DeploymentRequest'
            examples:
              upload_zip:
                summary: Upload a ZIP file
                value:
                  version: 1.0.0
                  file: <binary>
                  entrypoint_rel_path: src/app.py
                  region: aws.us-east-1a
                  force: false
                  env_vars:
                    FOO: bar
              github_public:
                summary: Deploy from GitHub source
                value:
                  version: 1.0.0
                  source:
                    type: github
                    url: https://github.com/org/repo
                    ref: main
                    path: apps/api
                    entrypoint: src/index.ts
                  region: aws.us-east-1a
                  force: false
                  env_vars:
                    FOO: bar
              github_private:
                summary: Deploy from private GitHub repo
                value:
                  version: latest
                  source:
                    type: github
                    url: https://github.com/org/private-repo
                    ref: main
                    path: apps/service
                    entrypoint: index.ts
                    auth:
                      method: github_token
                      token: ghs_***
            encoding:
              source:
                contentType: application/json
      responses:
        '201':
          description: Deployment created successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Deployment'
        '400':
          $ref: '#/components/responses/BadRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/InternalError'
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import fs from 'fs';
            import Kernel from '@onkernel/sdk';

            const client = new Kernel({
              apiKey: process.env['KERNEL_API_KEY'], // This is the default and can be omitted
            });

            const deployment = await client.deployments.create({
              entrypoint_rel_path: 'src/app.py',
              env_vars: { FOO: 'bar' },
              file: fs.createReadStream('path/to/file'),
              region: 'aws.us-east-1a',
              version: '1.0.0',
            });

            console.log(deployment.id);
        - lang: Python
          source: |-
            import os
            from kernel import Kernel

            client = Kernel(
                api_key=os.environ.get("KERNEL_API_KEY"),  # This is the default and can be omitted
            )
            deployment = client.deployments.create(
                entrypoint_rel_path="src/app.py",
                env_vars={
                    "FOO": "bar"
                },
                file=b"<binary>",
                force=False,
                region="aws.us-east-1a",
                version="1.0.0",
            )
            print(deployment.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"bytes\"\n\t\"context\"\n\t\"fmt\"\n\t\"io\"\n\n\t\"github.com/kernel/kernel-go-sdk\"\n\t\"github.com/kernel/kernel-go-sdk/option\"\n)\n\nfunc main() {\n\tclient := kernel.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tdeployment, err := client.Deployments.New(context.TODO(), kernel.DeploymentNewParams{\n\t\tEntrypointRelPath: kernel.String(\"src/app.py\"),\n\t\tEnvVars: map[string]string{\n\t\t\t\"FOO\": \"bar\",\n\t\t},\n\t\tFile:    io.Reader(bytes.NewBuffer([]byte(\"<binary>\"))),\n\t\tRegion:  kernel.DeploymentNewParamsRegionAwsUsEast1a,\n\t\tVersion: kernel.String(\"1.0.0\"),\n\t})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", deployment.ID)\n}\n"
components:
  schemas:
    DeploymentRequest:
      type: object
      description: >-
        App deployment request. Provide either file+entrypoint_rel_path or
        source.
      properties:
        version:
          type: string
          description: Version of the application. Can be any string.
          example: 1.0.0
          default: latest
        file:
          type: string
          format: binary
          description: ZIP file containing the application source directory
          example: '@path/to/file.zip'
        entrypoint_rel_path:
          type: string
          description: Relative path to the entrypoint of the application
          example: src/app.py
        source:
          $ref: '#/components/schemas/DeploymentSource'
        region:
          type: string
          description: Region for deployment. Currently we only support "aws.us-east-1a"
          example: aws.us-east-1a
          default: aws.us-east-1a
          const: aws.us-east-1a
        force:
          type: boolean
          description: Allow overwriting an existing app version
          example: false
          default: false
        env_vars:
          type: object
          description: >-
            Map of environment variables to set for the deployed application.
            Each key-value pair represents an environment variable.
          additionalProperties:
            type: string
      oneOf:
        - required:
            - file
            - entrypoint_rel_path
        - required:
            - source
    Deployment:
      type: object
      description: Deployment record information.
      properties:
        id:
          type: string
          description: Unique identifier for the deployment
          example: rr33xuugxj9h0bkf1rdt2bet
        status:
          type: string
          description: Current status of the deployment
          enum:
            - queued
            - in_progress
            - running
            - failed
            - stopped
          example: queued
        status_reason:
          type: string
          description: Status reason
          example: Deployment in progress
        region:
          type: string
          description: Deployment region code
          example: aws.us-east-1a
          const: aws.us-east-1a
        entrypoint_rel_path:
          type: string
          description: Relative path to the application entrypoint
          example: src/app.py
        env_vars:
          type: object
          description: Environment variables configured for this deployment
          additionalProperties:
            type: string
        created_at:
          type: string
          format: date-time
          description: Timestamp when the deployment was created
        updated_at:
          type: string
          format: date-time
          nullable: true
          description: Timestamp when the deployment was last updated
      required:
        - id
        - status
        - region
        - created_at
    DeploymentSource:
      type: object
      description: Source from which to fetch application code.
      properties:
        type:
          type: string
          description: Source type identifier.
          enum:
            - github
          example: github
        url:
          type: string
          description: Base repository URL (without blob/tree suffixes).
          example: https://github.com/org/repo
        ref:
          type: string
          description: Git ref (branch, tag, or commit SHA) to fetch.
          example: main
        path:
          type: string
          description: Path within the repo to deploy (omit to use repo root).
          example: apps/api
        entrypoint:
          type: string
          description: >-
            Relative path to the application entrypoint within the selected
            path.
          example: src/index.ts
        auth:
          type: object
          description: Authentication for private repositories.
          properties:
            method:
              type: string
              enum:
                - github_token
              description: Auth method
              example: github_token
            token:
              type: string
              format: password
              description: GitHub PAT or installation access token
              example: ghs_***
          required:
            - method
            - token
      required:
        - type
        - url
        - ref
        - entrypoint
    Error:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
          description: Application-specific error code (machine-readable)
          example: bad_request
        message:
          type: string
          description: Human-readable error description for debugging
          example: 'Missing required field: app_name'
        details:
          type: array
          description: Additional error details (for multiple errors)
          items:
            $ref: '#/components/schemas/ErrorDetail'
        inner_error:
          $ref: '#/components/schemas/ErrorDetail'
    ErrorDetail:
      type: object
      properties:
        code:
          type: string
          description: Lower-level error code providing more specific detail
          example: invalid_input
        message:
          type: string
          description: Further detail about the error
          example: Provided version string is not semver compliant
  responses:
    BadRequest:
      description: Bad Request – invalid input
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    NotFound:
      description: Resource not found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    InternalError:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````